#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "gpi.h"

void GP_error(char *name_variable, char *message);

#ifdef GPPROTOTYPE
char  *GP_sfetch(char *name_variable, char *def_val, char *message)
#else
     char  *GP_sfetch(name_variable,def_val,message)
     char *name_variable, *def_val, *message;
#endif
{
  char *string;

  string = (char *) malloc(MAX_STRING_LENGTH);

  if(sfetch(name_variable,string)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
      return string;
}

#ifdef GPPROTOTYPE
double GP_dfetch(char *name_variable, double def_val, char *message)
#else
     double GP_dfetch(name_variable,def_val,message)
     char *name_variable, *message; 
     double def_val;
#endif
{
  double val;
  if (dfetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
    return val;
}
   
#ifdef GPPROTOTYPE
float GP_ffetch(char *name_variable, float def_val, char *message)
#else
    float GP_ffetch(name_variable,def_val,message)
     char *name_variable, *message; 
     float def_val;
#endif
{
  float val;
  if (ffetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
    return val;
}
   

#ifdef GPPROTOTYPE
int GP_ifetch(char *name_variable, int def_val, char *message)
#else
     int GP_ifetch(name_variable,def_val,message)
     char *name_variable, *message; 
     int def_val;
#endif
{
  int val;

  if (ifetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
    return val;
}
   
void GP_error(char *name_variable, char *message)
{
  
  if (strcmp(message,"DEFAULT") == 0) 
    return;
  else if (strcmp(message,"WARNING") == 0) 
    {
      fprintf(stderr,"WARNING: using for %s the default value. \n", 
	      name_variable);
      return;
    }
  else if (strcmp(message,"SEVERE") == 0) 
    {
      fprintf(stderr,"SEVERE: the value for %s is not in the input files\n",name_variable);
      exit(-1);
    }
  else 
    {
      fprintf(stderr,"GetparC: allowed message values: DEFAULT, WARNING, SEVERE\n");
      exit(-1);
    }
}
